<template>
  <AppAbstractPage :breadcrumbs="breadcrumbs">
    <div
      slot="heading"
      class="pageHeading">
      <h1 class="heading _h1">
        Шины {{ title }}
      </h1>
    </div>

    <div
      slot="content"
      class="wheelsTyres _tyres">
      <div class="wheelsTyres-filters">
        <div class="wheelsTyres-toggle">
          <ul class="wheelsTyresToggle">
            <li class="wheelsTyresToggle-tab -active">
              <div class="wheelsTyresToggle-name">
                <span class="valueIsDesktop">Подобрать шины</span>
                <span class="valueIsMobile">Шины</span>
                <!-- <span class="counter">111</span> -->
              </div>

            </li>
            <li class="wheelsTyresToggle-tab">
              <flink
                class="wheelsTyresToggle-name"
                href="/wheels">
                <span class="valueIsDesktop">Подобрать диски</span>
                <span class="valueIsMobile">Диски</span>
                <!-- <span class="counter">111</span> -->
              </flink>
            </li>
          </ul>
        </div>
        <button
          class="buttonOnlyMobile"
          @click="changeDisplay($options.displayStates.FILTERS)">
          <span>
            Фильтры
            <template v-if="filtersGroup === $options.filtersGroups.PARAMS">по параметрам</template>
            <template v-if="filtersGroup === $options.filtersGroups.AUTO">по автомобилю</template>
            <span
              v-if="countSelectedFilters"
              class="counter">{{ countSelectedFilters }}</span>
          </span>
          <img
            svg-inline
            src="~/assets/svg/redesign/button-arrow-right.svg">
        </button>
        <div class="boxFilters">
          <TyresFilters
            v-model="filtersModel"
            :scrollable="filtersMobileScrollable"
            :values="filtersValues"
            :group="filtersGroup"
            @group-change="changeFilterGroup($event); resetFilters();"
            @hide="changeDisplay($options.displayStates.LIST)"
            @reset="resetFilters"
            class="__box-gray"
            :class="{ '-open-in-mobile': display === $options.displayStates.FILTERS }"/>
        </div>
      </div>

      <div
        class="wheelsTyres-marks">
        <template v-if="tags && tags.length">
          <button
            v-if="!tagsMobileScrollable"
            class="buttonOnlyMobile"
            @click="changeDisplay($options.displayStates.POPULAR)">
            <span>Популярные шины</span>
            <img
              svg-inline
              src="~/assets/svg/redesign/button-arrow-right.svg">
          </button>
          <div
            v-scroll-lock="tagsMobileScrollable"
            class="boxMarks"
            :class="{ '-open-in-mobile': display === $options.displayStates.POPULAR }">
            <div class="boxMarks-header">
              <div class="boxMarks-title">Популярное</div>
              <button
                @click="changeDisplay($options.displayStates.LIST)"
                class="boxMarks-close">
                <img
                  svg-inline
                  src="~/assets/svg/redesign/arrow-left-bold.svg">
              </button>
            </div>
            <ul class="boxMarks-list">
              <li
                v-for="tag in tags"
                :key="`mark-${tag.href}`"
                class="boxMarks-item">
                <flink
                  :href="tag.href"
                  @click.native="changeDisplay($options.displayStates.LIST)"
                  class="link linkLight">
                  {{ tag.label }}
                </flink>
              </li>
            </ul>
          </div>
        </template>
      </div>

      <div
        v-if="count"
        class="wheelsTyres-warning">
        <div class="row">
          <div class="heading _h2">
            {{ count | transChoose(['Найден', 'Найдено', 'Найдено']) }}
            {{ count | spacifyNumber }}
            {{ count | transChoose(['вариант', 'варианта', 'вариантов']) }}
          </div>
        </div>
      </div>

      <div class="wheelsTyres-table">
        <header class="wheelsTyres-table-header">
          <SelectSorting
            :options="sorting"
            slot="btn-sorting"
            @order-change="onOrderChange"/>
        </header>

        <AppTable
          class="tableWheelsTyres"
          :table-headings="$options.headings"
          :grid="grid"
          :has-lazy-load="lazyLoadEnabled"
          @load-data="showMore"
          @order-change="onOrderChange">
          <!-- Ячейки с данными для таблицы -->

          <template
            :slot="`unit-${$options.headings[0].name}`"
            slot-scope="{ part }">
            <div class="picture">
              <img
                v-if="isItemHasImage(part)"
                :src="getItemImage(part)"
                :alt="getItemImageAlt(part)">
              <img
                v-else
                svg-inline
                src="~/assets/svg/redesign/navigation-parts.svg">
            </div>
          </template>

          <template
            :slot="`unit-${$options.headings[1].name}`"
            slot-scope="{ part }">
            {{ part.part.manufacturer.brand }}
          </template>

          <template
            :slot="`unit-${$options.headings[2].name}`"
            slot-scope="{ part }">
            {{ part.modelName }}
          </template>

          <template
            :slot="`unit-${$options.headings[3].name}`"
            slot-scope="{ part }">
            {{ part.width }}/{{ part.profile }}
            R{{ part.diameter }}
            {{ part.loadIndex }}
            {{ part.speedIndex }}
          </template>

          <template
            :slot="`unit-${$options.headings[4].name}`"
            slot-scope="{ part }">
            {{ part.season }}
          </template>

          <template
            :slot="`unit-${$options.headings[5].name}`"
            slot-scope="{ part }">
            <span class="__no-wrap">от {{ part.minPrice | spacifyNumber }} ₽</span>
          </template>

          <template
            :slot="`unit-${$options.headings[6].name}`"
            slot-scope="{ part }">
            <flink
              :href="getItemHref(part)"
              target="_blank"
              class="button linkAsButton">
              Показать
            </flink>
          </template>
        </AppTable>
      </div>
    </div>
  </AppAbstractPage>
</template>

<script>
import {
  has,
  get,
  isEmpty,
  find,
  mapValues,
} from 'lodash-es';

import AppAbstractPage from '~/components/redesign/layout/app-abstract-page';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppModal from '~/components/redesign/app-modals/app-modal';
import AppCitySearch from '~/components/redesign/app-input/app-city-search';
import AppInputComposite from '~/components/redesign/app-input/app-input-composite';
import AppInputPhone from '~/components/redesign/app-input/app-input-phone';
import AppCheckbox from '~/components/redesign/app-input/app-checkbox';
import TyresFilters from '~/components/redesign/filter-groups/tyres-filters';
import SelectSorting from '~/components/redesign/app-select/select-sorting';
import AppTable from '~/components/redesign/app-table/app-table';

import mapFilters from '~/assets/js/helpers/map-filters';
import { Tyres as Headings } from '~/assets/js/mocks/table/headings';
import RouteParamsPrefixMapping from '~/assets/js/model/tyres/route-params-prefixes';
import InitialFiltersModel from '~/assets/js/model/tyres/initial-filters-model';
import TyresWheelsMixin from '~/assets/js/mixins/redesign/tyres-wheels';
import SeoBaseMixin from '~/assets/js/mixins/seo/base';
import SeoMixin from '~/assets/js/mixins/seo/pages/main/tyres';

const apiUrls = Object.freeze({
  data: '/_main/tyreItem/list',
  filters: '/_main/tyreItem/filters',
  tags: '/_main/tyreItem/tags',
  count: '/_main/tyreItem/count',
});

export default {
  name: 'Tyres',
  components: {
    AppAbstractPage,
    AppButton,
    AppModal,
    AppCitySearch,
    AppInputComposite,
    AppInputPhone,
    AppCheckbox,
    TyresFilters,
    SelectSorting,
    AppTable,
  },
  mixins: [TyresWheelsMixin('tyres', apiUrls), SeoBaseMixin, SeoMixin],
  scrollToTop: false,
  async asyncData({ app, params, error }) {
    const limit = 12;
    const order = {
      field: 'min_price',
      direction: 'asc',
    };
    const filtersModel = { ...InitialFiltersModel };

    const apiCriteria = Object.keys(params)
      .filter(key => params[key])
      .reduce((result, key) => {
        result[key] = params[key].substring(RouteParamsPrefixMapping[key].length + 1);
        return result;
      }, {});
    const apiRequestParams = {
      criteria: apiCriteria,
      limit: isEmpty(apiCriteria) ? 0 : limit,
      order,
    };

    try {
      const [
        { data },
        { data: filtersValues },
        { data: tagsOrigins },
        { data: count },
      ] = await Promise.all([
        app.$axios.$get(apiUrls.data, { params: apiRequestParams }).catch(e => console.error(e)),
        app.$axios.$get(apiUrls.filters, { params: apiRequestParams }).catch(e => console.error(e)),
        !has(apiCriteria, 'model')
          ? app.$axios.$get(apiUrls.tags, { params: apiRequestParams }).catch(e => console.error(e))
          : Promise.resolve({ data: null }),
        !isEmpty(apiCriteria)
          ? app.$axios.$get(apiUrls.count, { params: apiRequestParams }).catch(e => console.error(e))
          : Promise.resolve({ data: null }),
      ]);

      Object.keys(params).forEach((key) => {
        if (!params[key]) {
          return;
        }

        const value = params[key].substring(RouteParamsPrefixMapping[key].length + 1);
        const model = find(filtersValues[key], o => String(o.id) === String(value));
        if (!model) {
          error({ statusCode: 404 });
          return;
        }
        filtersModel[key] = model;
      });

      return {
        data,
        filtersValues: mapValues(filtersValues, filter => (Array.isArray(filter) ? filter : [])),
        filtersModel,
        tagsOrigins: tagsOrigins || [],
        count: count || 0,
        limit,
        order,
      };
    } catch (e) {
      console.error(e);
      error({ statusCode: 500 });
      return {};
    }
  },
  computed: {
    title() {
      let title = '';

      const seasonsCompare = {
        summer: 'летние',
        winter: 'зимние',
        'all-seasons': 'всесезонные',
      };
      const countSelected = Object.keys(this.apiCriteria).length;

      if (countSelected === 1) {
        const key = Object.keys(this.apiCriteria)[0];
        if (this.filtersModel[key]) {
          switch (key) {
            case 'width': title = `шириной ${this.filtersModel[key].name} мм`; break;
            case 'profile': title = `профиля ${this.filtersModel[key].name}`; break;
            case 'diameter': title = `диаметром ${this.filtersModel[key].name} дюймов`; break;
            case 'brand': title = `${this.filtersModel[key].name}`; break;
            case 'season': title = seasonsCompare[this.filtersModel[key].id]; break;
            default: title = '';
          }
        }
      }

      if (countSelected > 1) {
        if (
          has(this.apiCriteria, 'carManufacturer') && (
            !has(this.apiCriteria, 'carModel')
            || !has(this.apiCriteria, 'carYear')
          )
        ) {
          return title;
        }

        if (
          has(this.apiCriteria, 'width')
          && has(this.apiCriteria, 'profile')
        ) {
          title = `${this.filtersModel.width.name}/${this.filtersModel.profile.name}`;
        } else if (has(this.apiCriteria, 'width')) {
          title = `${this.filtersModel.width.name} мм`;
        } else if (has(this.apiCriteria, 'profile')) {
          title = `профиля ${this.filtersModel.profile.name}`;
        }

        if (has(this.apiCriteria, 'diameter')) {
          title += ` R${this.filtersModel.diameter.name}`;
        }
        if (has(this.apiCriteria, 'carManufacturer')) {
          title += `для ${this.filtersModel.carManufacturer.name}`;
        }
        if (has(this.apiCriteria, 'carModel')) {
          title += ` ${this.filtersModel.carModel.name}`;
        }
        if (has(this.apiCriteria, 'carType')) {
          title += ` ${this.filtersModel.carType.name}`;
        }
        if (has(this.apiCriteria, 'carYear')) {
          title += ` ${this.filtersModel.carYear.name} года`;
        }
        if (has(this.apiCriteria, 'model')) {
          title = `${this.filtersModel.model.name} ${title}`;
        }
        if (has(this.apiCriteria, 'brand')) {
          title = `${this.filtersModel.brand.name} ${title}`;
        }
        if (has(this.apiCriteria, 'season')) {
          title = `${seasonsCompare[this.filtersModel.season.id]} ${title}`;
        }
      }

      return title;
    },
    breadcrumbs() {
      const breadcrumbs = [
        {
          name: 'Шины',
          url: '/tyres',
        },
      ];
      if (this.title) {
        breadcrumbs.push({
          name: `Шины ${this.title}`,
          url: '',
        });
      }
      breadcrumbs[breadcrumbs.length - 1].url = '';
      return breadcrumbs;
    },
  },
  created() {
    this.$options.headings = Headings;
    this.$options.InitialFiltersModel = InitialFiltersModel;
    this.$options.RouteParamsPrefixMapping = RouteParamsPrefixMapping;
  },
  methods: {
    ...mapFilters(['brandSlug', 'vendorCodeSlug']),
    // TODO: Нужна проверка на то что значение корректны
    getItemHref(item) {
      const url = ['/poisk-po-nomeru'];
      url.push(this.brandSlug(get(item, 'part.manufacturer.brand', '')));
      url.push(this.vendorCodeSlug(get(item, 'part.vendorCode', '')));
      return url.join('/');
    },
    isItemHasImage(item) {
      return item.part.image.length;
    },
    getItemImage(item) {
      const url = ['/files/part-image'];
      url.push(item.part.image[0].id);
      url.push('medium');
      url.push(`${item.part.image[0].mediumFile.name}.jpg`);
      return url.join('/');
    },
    getItemImageAlt(item) {
      return [
        item.modelName,
        item.part.manufacturer.brand,
        item.season,
        `${item.width}/${item.profile}`,
        item.diameter,
        item.loadIndex,
        item.speedIndex,
      ].join(' ').replace(/[^a-zA-Zа-яА-ЯёЁ0-9 \\/]/g, '');
    },
  },
};
</script>

<style lang="postcss">
  /*Стили для страниц Шины + Диски*/
  @import "~/assets/css/components/wheels-tyres-pages.css";
</style>
